#ifndef ANTPLUS_HEARTRATEPROFILEPRIVATEDEFINES_h
#define ANTPLUS_HEARTRATEPROFILEPRIVATEDEFINES_h

/* Channel Config */
#define ANTPLUS_HEARTRATE_CHANNELTYPE CHANNEL_TYPE_BIDIRECTIONAL_RECEIVE
#define ANTPLUS_HEARTRATE_DEVICETYPE 120
#define ANTPLUS_HEARTRATE_CHANNELPERIOD 8070
// 30 / 2.5 = 12
#define ANTPLUS_HEARTRATE_SEARCHTIMEOUT 12

/* Base DataPage */
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_DATAPAGE_BYTE 0
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_TOGGLE_BYTE   0
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_HEARTBEATEVENTTIMELSB_BYTE 4
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_HEARTBEATEVENTTIMEMSB_BYTE 5
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_HEARTBEATCOUNT_BYTE 6
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_COMPUTEDHEARTRATE_BYTE 7

#define ANTPLUS_HEARTRATE_DATAPAGEBASE_DATAPAGE_MASK 0x7F
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_TOGGLE_MASK   0x80

#define ANTPLUS_HEARTRATE_DATAPAGEBASE_TOGGLE_SHIFT  7
#define ANTPLUS_HEARTRATE_DATAPAGEBASE_HEARTBEATEVENTTIMEMSB_SHIFT 8

/* Default DataPage */
#define ANTPLUS_HEARTRATE_DATAPAGE_DEFAULT_NUMBER 0

/* Cumulative Operating Time */
#define ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_NUMBER 1

#define ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_LSB_BYTE 1
#define ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MID_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MSB_BYTE 3

#define ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MID_SHIFT 8
#define ANTPLUS_HEARTRATE_DATAPAGE_CUMULATIVEOPERATINGTIME_TIME_MSB_SHIFT 16

/* Manufacturer Information */
#define ANTPLUS_HEARTRATE_DATAPAGE_MANUFACTURERINFORMATION_NUMBER 2

#define ANTPLUS_HEARTRATE_DATAPAGE_MANUFACTURERINFORMATION_MANUFACTUREREIDLSB_BYTE 1
#define ANTPLUS_HEARTRATE_DATAPAGE_MANUFACTURERINFORMATION_SERIALNUMBERLSB_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_MANUFACTURERINFORMATION_SERIALNUMBERMSB_BYTE 3

#define ANTPLUS_HEARTRATE_DATAPAGE_MANUFACTURERINFORMATION_SERIALNUMBERMSB_SHIFT 8

/* Product Information */
#define ANTPLUS_HEARTRATE_DATAPAGE_PRODUCTINFORMATION_NUMBER 3

#define ANTPLUS_HEARTRATE_DATAPAGE_PRODUCTINFORMATION_HARDWAREVERSION_BYTE 1
#define ANTPLUS_HEARTRATE_DATAPAGE_PRODUCTINFORMATION_SOFTWAREVERSION_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_PRODUCTINFORMATION_MODELNUMBER_BYTE 3

/* Previous Heart Beat */
#define ANTPLUS_HEARTRATE_DATAPAGE_PREVIOUSHEARTBEAT_NUMBER 4

#define ANTPLUS_HEARTRATE_DATAPAGE_PREVIOUSHEARTBEAT_MANUFACTURERSPECIFIC_BYTE 1
#define ANTPLUS_HEARTRATE_DATAPAGE_PREVIOUSHEARTBEAT_PREVIOUSHEARTBEATEVENTTIMELSB_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_PREVIOUSHEARTBEAT_PREVIOUSHEARTBEATEVENTTIMEMSB_BYTE 3

#define ANTPLUS_HEARTRATE_DATAPAGE_PREVIOUSHEARTBEAT_MANUFACTURERSPECIFIC_INVALID 0xFF

#define ANTPLUS_HEARTRATE_DATAPAGE_PREVIOUSHEARTBEAT_PREVIOUSHEARTBEATEVENTTIMEMSB_SHIFT 8

/* Swim Interval Summary */
#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_NUMBER 5

#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_INTERVALAVERAGEHEARTRATE_BYTE 1
#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_INTERVALMAXIMUMHEARTRATE_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_SESSIONAVERAGEHEARTRATE_BYTE 3

#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_INTERVALAVERAGEHEARTRATE_INVALID 0
#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_INTERVALMAXIMUMHEARTRATE_INVALID 0
#define ANTPLUS_HEARTRATE_DATAPAGE_SWIMINTERVALSUMMARY_SESSIONAVERAGEHEARTRATE_INVALID 0

/* Capabilities */
#define ANTPLUS_HEARTRATE_DATAPAGE_CAPABILITIES_NUMBER 6

#define ANTPLUS_HEARTRATE_DATAPAGE_CAPABILITIES_FEATURESSUPPORTED_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_CAPABILITIES_FEATURESENABLED_BYTE   3

#define ANTPLUS_HEARTRATE_DATAPAGE_CAPABILITIES_FEATURES_MASK 0xC7

/* Battery Status */
#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_NUMBER 7

#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_BATTERYLEVEL_BYTE 1
#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_FRACTIONALBATTERYVOLTAGE_BYTE 2
#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_COARSEBATTERYVOLTAGE_BYTE 3
#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_BATTERYSTATUS_BYTE 3

#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_COARSEBATTERYVOLTAGE_MASK 0x0F
#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_BATTERYSTATUS_MASK 0x70

#define ANTPLUS_HEARTRATE_DATAPAGE_BATTERYSTATUS_BATTERYSTATUS_SHIFT 4

#endif // ANTPLUS_HEARTRATEPROFILEPRIVATEDEFINES_h